unit Sbrs;

{$define SPLASHONE}

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms,
Controls, Buttons, StdCtrls, ExtCtrls, Dialogs, Gauges
{,splash }
;


const
ssize = 256;

type
TICKTIME = record
  waitfor,oldcount: longint;
end;

{$ifdef DELPHI_AS_USUAL+BOGUS}
HMSRec = record
  Hours: byte;
  Minutes: byte;
  Seconds: byte;
  NotUsed: byte;
end;
//see usage in jmp3 unit1.pas. Well the commented-out junk.
{$endif}

wstring = array[0..ssize] of char;

apiarg = record
  delphi : string;
  windows : wstring;
end;

{  $define see16}
{  $define waitsplash}
{$define ONESPLASH}  {just have a single 16-color splash}


const

{Gactivated : boolean = false;  }
Splashed : boolean = true;
working : boolean = false;

Stx {: char} = chr(2);
Etx {: char} = chr(3);
Eot {: char} = chr(4);
Ack {: char} = chr(6);
Lf  {: char} = chr(10);
Cr  {: char} = chr(13);
{Ff  = chr(12); }
Del {: char} = #127;
ESC = #27;
CTL = $40;
LNEND = CR+LF;

CTLX = chr(ord('X')-CTL);
CTLC = chr(ord('C')-CTL);

CRLF {: string} =  CR+LF {chr(13)+chr(10)};


CheckWait = 500;

CharsInFileRoot = 8;    { in win 3.1 of course. }

fonname = 'JGOFONTT';

type DlgPos = (UpperLeft, UpperRight, LowerLeft, LowerRight);

{     $I wlc6help.i}
{      $I Delphi.i}
{        $I wjvers.i}

procedure mswait(ms: longint);
function delayed(var t:TICKTIME; howlong: longint):boolean;
procedure quickbeep;
function contexthelp(number:integer):boolean;
function helpoid(sHELPJUNK:pchar):boolean;
procedure hglass;
procedure dcursor;
function findhelp(form: Tform):boolean;
procedure ChangeToProgramDirectory;
function programdirectory:string;
{ procedure finalsbrs; }
procedure deslash(var what:string);
function programname:string;
function formatint(value:longint; size:integer):string;
function formathex(value:longint; size:integer):string;
function isdigit(c:char):boolean;
function isspace(c:char):boolean;
function ischar(c:char):boolean;
function isprint(c:char):boolean;
function hextoint(s:string):longint;
procedure intrange(low, high:integer; var what:integer);
procedure wordrange(low, high:word; var what:word);
procedure longrange(low,high:longint; var what:longint);
function hprintf(handle:integer; const TheFormat:string; const Args: array of
const):integer;
function hgets(handle:integer; var dst:string):boolean;
function tokenate(const s:string):boolean;
function tokenhget(handle:integer):boolean;
function boolstring(what:boolean):string;
function jgoStrToInt(const S: string): Longint;
function jgoi(const S: string; const start, count:integer):longint;
procedure initemsg;
function spaces(count:integer):string;
procedure flip(var what:boolean);
{function colorbright(color:Tcolor):integer; }
procedure showgerror;
function delineend(s:string):string;
function unline(s:string):string;
function extractname(const s:string):string;
function despace(const s:string):string;
function loadWLC6font:boolean;
procedure delphiwin(var what:apiarg);
procedure windelphi(var what:apiarg);
function ipos(substr:string; index:integer; s:string):integer;
procedure removecharacter(var s:string; where:integer);
{ if count<>0, then initialize hung count; if 0, then return true if
counted down.}
function hung(count:integer):boolean;
function DialogPos(const Msg: string;
AType: TMsgDlgType; AButtons: TMsgDlgButtons;
HelpCtx: Longint;
pos:DlgPos): Word;
function pixelbits:integer;
function lowest(one, two:integer):integer;
procedure switchint(var one, two: integer);
{procedure switchcase(var key:char);}
procedure makeupper(var key:char);
{ returns true if user answers yes. }
function usuref(
const TheFormat: string;
const Args:array of const):boolean;
function usure(s:string):boolean;
procedure errorf(
const TheFormat: string;
const Args:array of const);
function emptyspace(s:string; i:integer):char;
procedure infof(
const TheFormat: string;
const Args:array of const);
function commaoid(s:string):string;
procedure colonoid(var s:string; var x:longint);
function ualphan(s:string):string;
procedure editselect(edit:tedit);
procedure replacechar(old,new:char; var dst:string);
function htell(handle:integer):longint;
function hrewind(handle:integer):boolean; {returns good if it worked.}
function firstselected(listbox:Tlistbox):integer;
function isdefault(s:string):boolean;
function hexoid(s:string):longint;
function lastchar(s:string):string;
{returns value of first number in a string, i.e. "unit12" returns 12.}
function firstnumber(s:string):integer;
{ called like
nfree(Tobject(bingo)); }

procedure nfree(var what:Tobject);
function argumentize(s:string):string;
function directorized(s:string):boolean;

procedure slash(var what:string);
function fslash(what:string):string;

procedure cwdize(var s:string);
function pgmdir:string;
procedure pgmdirize(var s:string);
function fpgmdirize(s:string):string;
function cwd:string;
function fcwdirize(s:string):string;
function es(s:string; i:integer):char;
//function programdirectory:string;
procedure delphi_yield;
function safe_format(
const TheFormat: string;
const Args:array of const):string;
procedure stupidscroll(memo:Tmemo);


var
printerheld:boolean;



const
FILEONTOP = 'notontop';

Amsgreleased:boolean = true;    {dedicated to Achjgmsg}

const
TOKENCOUNT = 30;
TokenSize = 20;

var
tokenarray : array[1..TOKENCOUNT] of string[TokenSize];
tokens : integer;
tokenstr:string;    { the original string. }

Gerror:string;      { primitive error message. }

Ginput:string;      { harmless general-purpose. }

Gdummy:string[1];


{****************************************************************************
****************************************************************************}

implementation

{$define BETTERTIMES}



uses SysUtils,
{$ifdef BETTERTIMES}
MMSystem, //where TimeGetTime is carefully hidden.
{$endif}
messages, main {, options};


{****************************************************************************
****************************************************************************}
{$ifdef BETTERTIMES}

{if howlong, set wait to howlong. If 0, return YES if previous wait is
timed-out. Should be in ticks.// No u idiot in ms. }
function delayed(var t:TICKTIME; howlong: longint):boolean;
var
msnow : longint;
begin
  msnow := TimeGetTime;  { that's a microsoft function. }

  if (howlong>0) then begin
//    if (howlong < 60) then
//    howlong := 60;
// timegettime is supposedly ms timer.
    t.oldcount := msnow;
    t.waitfor := howlong;
    result := false;
    exit;
  end;
  result :=
  (msnow-t.oldcount)
  >= t.waitfor;
end;

{$else}     {$define BETTERTIMES}


{if howlong, set wait to howlong. If 0, return YES if previous wait is
timed-out. Should be in ticks.// No u idiot in ms. }
function delayed(var t:TICKTIME; howlong: longint):boolean;
var
msnow : longint;
begin
  msnow := GetTickCount;  // that's a ms function.

{ the allgorithm laughs at rollover, so don't need this...
  if (msnow <0) then begin
    result := true;
    exit;
  end;

Actually I suspect i could've just left it in there the way it is // right!
Except won't this stupid Pascal flag an error when it rolls-ver? Let's see.
//no. The way to do it is do the operation in the DLL of course. That's
why I have it. // well actuallly in the event is turned-out I *didn't* need
the DLL. sigh.
}

  if (howlong>0) then begin
    if (howlong < 60) then
    howlong := 60;
    t.oldcount := msnow;
    t.waitfor := howlong;
    result := false;
    exit;
  end;
  result :=
  (msnow-t.oldcount)
  >= t.waitfor;
end;

{$endif}     {$define BETTERTIMES}

{****************************************************************************
****************************************************************************}

procedure mswait(ms: longint);
const
waiting:boolean = false;
var
t : TICKTIME;
begin
  if waiting then
  exit;

  if ms<1 then
  exit;   //do nothing.

  waiting := true;

  if ms > 10000 then
  ms := 10000;

  delayed(t,ms);
  while not delayed(t,0) do
  begin
    application.processmessages;
  end;
  waiting := false;
end;

{****************************************************************************
****************************************************************************}

procedure quickbeep;
begin
  messagebeep($FFFF);
end;

function contexthelp(number:integer):boolean;
begin
  hglass;
  result :=
  Application.helpcommand(
  HELP_CONTEXT,
  number
  );
  dcursor;
end;

function helpoid(sHELPJUNK:pchar):boolean;
begin
  hglass;
  result :=
  Application.helpcommand(
  HELP_PARTIALKEY,
  longint(sHELPJUNK)
  );
  dcursor;
end;

{-----------------------------------------------------------}
procedure hglass;
begin
  screen.cursor := crHourGlass;
end;

procedure dcursor;
begin
  screen.cursor := crDefault;
end;

{-----------------------------------------------------------}

function itsinside(where:Tpoint; acontrol:TWinControl):
boolean;
begin
  result :=
  (where.x > acontrol.left) and
  (where.x < (acontrol.left+acontrol.width) ) and

  (where.y > acontrol.top) and
  (where.y < (acontrol.top + acontrol.height) );
end;

function TwinControlAtPos(where: Tpoint;
form:Tcomponent):TWinControl;
var
index : longint;
begin

  for index := 0 to
  form.componentcount-1 do begin
    if (form.components[index] is TWinControl)
    then begin
      result :=
      form.components[index] as TWinControl;
      if itsinside(where,result) then
      exit;
    end;
  end;

  result := nil;
end;

{Return a help context for the control, or if
no such, 0, or if acontrol is nil, 0.

Delphi documentation lies about presence of
helpcontext so we will cut 'n' try.
//so I found a chart on page 114,
*Developing Custom Delphi Components*, Konopka,
Coriolis, 1996 which seems to be helpful. I.e., a
TWinControl seems the most primitive thing with a
helpcontext. }

function TwinHelpContext(acontrol:TWinControl):
longint;
begin
  if (acontrol <> nil) then begin
    result := acontrol.helpcontext;
    exit;
  end;
  result := 0;
end;

function findhelp(form: Tform):boolean;
var
CurPos: Tpoint;
acontext : longint;

{column, row:integer;}

begin
  result := false;

  GetCursorPos(CurPos);
  CurPos := form.ScreenToClient(CurPos);

  acontext :=
  TwinHelpContext(
  TwinControlAtPos(CurPos,form as Tcomponent)
  );

  if (acontext <> 0) then begin
    result := true;
    contexthelp(acontext);
{    contexthelp(51); }
  end;

end;


{---------------------
HERE'S HOW IT'S USED:

procedure Twjnetform.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key=vk_F1) then begin
    if (findhelp(wjnetform)) then begin

    [the form's key preview property must be true for this
    to work; but I thought I tried that six or seven times
    and it still didn't work. What *doesn't* seem to make
    a difference:
      form's showhint; it's false. IN WHRP it's true so.
      Application.HintPause := 1500;  // no diff
      Application.OnShowHint := DoShowHint; //nope.
    ]

      Key := 0;
    end;
  end;

end;

----------------------}

{------------------------------------------------------------------------}

function formatint(value:longint; size:integer):string;
var i:integer;
begin
  result := format('%*d',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

function formathex(value:longint; size:integer):string;
var i:integer;
begin
  result := format('%*x',[size,value]);
  for i := 1 to length(result) do begin
    if result[i]=' ' then
    result[i] := '0';
  end;
end;

{---------------------------------------------------------------}
function isdigit(c:char):boolean;
begin
  result := false;
  case c of
    '0'..'9': result := true;
  end;
end;


{---------------------------------------------------------------}
function hextoint(s:string):longint;
var
i, anumber:integer;
begin
  result := 0;
  anumber := 0;

  for i:=1 to length(s) do begin
    case s[i] of
      '0'..'9': anumber := ord(s[i])-ord('0');
      'A'..'F': anumber := ord(s[i])-ord('A')+10;
      'a'..'f': anumber := ord(s[i])-ord('a')+10;
      else exit; {exit function at non-hex, i.e. like JgoStrToInt.}
    end;

    result := result*16;
    inc(result,anumber);
  end;
end;

{---------------------------------------------------------------}
procedure intrange(low, high:integer; var what:integer);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure wordrange(low, high:word; var what:word);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

procedure longrange(low,high:longint; var what:longint);
begin
  if (what < low) then what := low;
  if (what > high) then what := high;
end;

{--------------------------------------------------------------}
function boolstring(what:boolean):string;
begin
  if (what) then
  result := 'true'
  else
  result := 'false';
end;




{--------------------------------------------------------------}
function hprintf(handle:integer;
const TheFormat:string;
const Args: array of const):integer;
var
s:string;
p : array[0..257] of char;
count:integer;
begin

{
function StrPCopy(Dest: PChar; Source: string): PChar;
}
  result := -1;
  try
    s := format(Theformat,args);
    count := length(s);
    StrPCopy(p,s);
    result := FileWrite(handle,p,count);
    if result<>count then
    result := -1;
  except
  end;
end;

{--------------------------------------------------------------}
function isspace(c:char):boolean;
begin
  result := false;
  case c of
    ' ', chr(9), chr(10), chr(13): result := true;
  end;
end;

function ischar(c:char):boolean;
begin
  result := not isspace(c);
end;

function isprint(c:char):boolean;
begin
  if c < ' ' then
  result := false
  else
  result := ischar(c);
end;

function despace(const s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    if not isspace(s[i]) then
    result := result + s[i];
  end;
end;

function ualphan(s:string):string;
var
i:integer;
begin
  result := '';
  for i:=1 to length(s) do begin
    case s[i] of
      'a'..'z','A'..'Z','0'..'9':
      result := result + UpCase(s[i]);
    end;
  end;
end;




{--------------------------------------------------------------}
{function FileRead(Handle: Integer; var Buffer; Count: Longint): Longint;}

function hgets(handle:integer; var dst:string):boolean;
var
c:char;
begin
  result := true;

  dst := '';

  while true do begin
    if FileRead(handle,c,1)<>1 then begin
      result := false;
      break;
    end;

    case c of
{stupid compiler doesn't like Cr constant !? }
      {Cr} chr(13): break;
      {LF} chr(10): ;       { throw away now. }
    else
      dst := dst+c;
{     if (length(dst) >= HIGH(dst)) then
      break; }
    end;
  end;
end;

function hrewind(handle:integer):boolean; {returns good if it worked.}
begin
  result :=
  (FileSeek(Handle, 0,0 )<> -1);
end;

function htell(handle:integer):longint;
begin
  result :=
  FileSeek(Handle,0,1);
end;

function tokenate(const s:string):boolean;
var
i:integer;
c:char;

state : (spaces, characters);

begin
  for i := low(tokenarray) to high(tokenarray) do
  tokenarray[i] := '';

  state := spaces;

  tokens := low(tokenarray)-1;  { pre decrement. }

  for i := 1 to length(s) do begin
    c := s[i];
    case state of
      spaces: begin
        if ischar(c) then begin
          state := characters;

          inc(tokens);
          tokenarray[tokens] := c;  {1st character.}

        end;
      end;

      characters: begin
        if isspace(c) then begin

          if tokens >= high(tokenarray) then
          break;

          state := spaces;

        end
        else
        tokenarray[tokens] := tokenarray[tokens]+c;
      end;
    end;
  end;

  result := tokens > 0;

end;


{ tries to get a string from the handle, and then tokenates it,
leaving the results in the tokenarray, and the tokencount in tokens.
}

function tokenhget(handle:integer):boolean;
begin
  result := false;

  while true do begin

    if not hgets(handle,tokenstr) then
    exit;

    if (length(tokenstr)<1) or
    (tokenstr[1]=';') then
    continue;             { dump empty, comments }

    tokenate(tokenstr);
    break;
  end;

  result :=true;

end;

{-------------------------------------------------------------}

{same as StrToInt but doesn't crash at empty etc.}
function jgoStrToInt(const S: string): Longint;
var
i: integer;
minus : boolean;
r : longint;
begin
  r := 0;
  minus := false;

  for i := 1 to length(S) do begin
    case S[i] of
      ' ': ;  { throw away leading spaces }

      '0'..'9':
      r := (r * 10) + (ord(S[i])-ord('0'));

      '-':
      minus := true;

    else break;
    end
  end;

  result := r;

  if (minus) then
  result := -result;
end;


function jgoi(const S: string; const start, count:integer):longint;
begin
  result :=
  JgoStrToInt(copy(s,start,count));
end;


procedure initemsg;
begin
  Gerror := 'unknown';
end;

function spaces(count:integer):string;
begin
  result := '';
  while count>0 do begin
    result := result + ' ';
    dec(count);
  end;
end;

procedure flip(var what:boolean);
begin
  what := not what;
end;

{
function colorbright(color:Tcolor):integer;
begin
  result := (
  ((color and $FF0000) shr 16) +
  ((color and $00FF00) shr 8) +
  ((color and $0000FF))
  ) div 3;
end;
}

procedure showgerror;
begin
  MessageDlg('Sorry, error: '+Gerror,
  mtError,[mbOK],0);
end;


{remove the last line end.}
function delineend(s:string):string;
var
count: integer;
begin
  count := length(s);
  if (count >= 2) and (s[count-1]=CR) then
  result := copy(s,1,count-2)
  else
  result := s;
end;

{remove bunches of last line ends}
function unline(s:string):string;
var
i:integer;
begin
  for i := 1 to 5 do
  s := delineend(s);
  result := s;
end;

function extractname(const s:string):string;
var
i:integer;
begin
  result := extractFileName(s);
  i := pos('.',result);
  if i>0 then
  result := copy(result,1,i-1);

end;


{--------------------------------------------------------------}
const
WLC6fon = 'WLCFONT.FON';
WLC6ttf = '' {'WLBAR.TTF'};

fot = 'W&L&N&T&.FOT';

fotname : apiarg =
(
delphi : fot;
windows : fot
);


fonloaded : boolean = false;
ttfloaded : boolean = false;

var
fontfilename: apiarg;

procedure killfot;
begin;
  DeleteFile(fotname.delphi);
end;


procedure unloadWLC6font;
begin
  if fonloaded and
  removefontresource(WLC6fon) then begin
    fonloaded := false;
    SendMessage($FFFF,WM_FONTCHANGE,0,0);
  end;

  if ttfloaded and
  removefontresource(fotname.windows) then begin
    ttfloaded := false;
    SendMessage($FFFF,WM_FONTCHANGE,0,0);
    killfot;
  end;
end;

function loadWLC6font:boolean;
const
done : boolean = false;
var
systemdir : apiarg;

begin

  if done then begin
    result := fonloaded and ttfloaded;
    exit;
  end;

  done := true;

{ do WLC6.FON. }
  if AddFontResource(
  WLC6fon) >= 1 then begin
    SendMessage($FFFF,WM_FONTCHANGE,0,0);
    fonloaded := true;

{ do a true type ttf. }
{but what if there is none? }
  if length(WLC6ttf)<1 then begin
    result := fonloaded;
    exit;
  end;

{ erase the fot, in case we exitted prematurely and it's still there }
  killfot;

{ setup the FOT name. }
  getsystemdirectory(@systemdir.windows,SSIZE);
  windelphi(systemdir);
  fotname.delphi :=
  systemdir.delphi + '\' +
  fotname.delphi;
  delphiwin(fotname);

  fontfilename.delphi := expandfilename(WLC6ttf);
  delphiwin(fontfilename);

{ create the fot. }
    if CreateScalableFontResource(
    0,
    fotname.windows,
    fontfilename.windows,
    nil) then begin
      if AddFontResource(fotname.windows)>=1 then begin
        SendMessage($FFFF,WM_FONTCHANGE,0,0);
        ttfloaded := true;
      end;
    end;


  end;


  result := fonloaded and ttfloaded;
end;
{--------------------------------------------------------------}

procedure delphiwin(var what:apiarg);
begin
  StrplCopy(@what.windows,what.delphi,high(what.windows));
end;

procedure windelphi(var what:apiarg);
begin
  what.delphi := StrPas(what.windows);
end;

{return position in s of substr, but starting at index. 0 if not
there.}
function ipos(substr:string; index:integer; s:string):integer;
begin
  result := pos(substr,copy(s,index,255));
  if (result>0) then
  inc(result,index-1);
end;

{--------------------------------------------------------------}
procedure removecharacter(var s:string; where:integer);
begin
  if where>1 then
  s := copy(s,1,where-1)+copy(s,where+1,255)
  else
  s := copy(s,2,255);
end;

function hung(count:integer):boolean;
const
hungcount : integer = 0;
begin
  result := false;

  if count > 0 then
  hungcount := count
  else if hungcount=0 then
  result := true
  else begin
    dec(hungcount);
    if hungcount=0 then
    result := true;
  end;
end;

{
function MessageDlgPos(const Msg: string; AType: TMsgDlgType;
  AButtons: TMsgDlgButtons; HelpCtx: Longint; X, Y: Integer): Word;
}

function DialogPos(const Msg: string;
AType: TMsgDlgType; AButtons: TMsgDlgButtons;
HelpCtx: Longint;
pos:DlgPos): Word;
var
height,width,
x,y:integer;
const
  MHEIGHT = 100;
  MWIDTH = 450; { just hopeless guesses }
begin

  height := getsystemmetrics(SM_CYFULLSCREEN);
  width  := getsystemmetrics(SM_CXFULLSCREEN);

  case pos of
    UpperRight: begin
      x := width - MWIDTH;
      y := 0;
    end;

    LowerLeft: begin
      x := 0;
      y := height - MHEIGHT;
    end;

    LowerRight: begin
      x := width - MWIDTH;
      y := height-MHEIGHT;
    end;

  else

//    UpperLeft: begin
    x := 0;
    y := 0;
//    end;

  end;

  result :=
  MessageDlgPos(msg,atype,Abuttons,HelpCtx,x,y);

end;

function pixelbits:integer;
var
ahandle : HDC;
begin
  ahandle:= CreateCompatibleDC(0);
  result := GetDeviceCaps(ahandle,BITSPIXEL);
  DeleteDC(ahandle);
end;

function lowest(one, two:integer):integer;
begin
  if (one < two) then
  result := one
  else
  result := two;
end;

procedure switchint(var one, two: integer);
var t : integer;
begin
  t := one;
  one := two;
  two := t;
end;

{
procedure switchcase(var key:char);
var
x:integer;
begin
  x := ord(key);
  case key of
    'A'..'Z': key := chr(x+$20);
    'a'..'z': key := chr(x-$20);
  end;
end;
}

procedure makeupper(var key:char);
var
x:integer;
begin
  x := ord(key);
  case key of
{    'A'..'Z': key := chr(x+$20);      }
    'a'..'z': key := chr(x-$20);
  end;
end;


function usure(s:string):boolean;
begin
  result :=
  MessageDlg(s,mtConfirmation,[mbYes,mbNo],0)
  = mrYES;
end;

procedure errorf(
const TheFormat: string;
const Args:array of const);
begin
  MessageDlg(format(Theformat,args),mtError,[mbOK],0);
end;

procedure infof(
const TheFormat: string;
const Args:array of const);
begin
  MessageDlg(format(Theformat,args),mtInformation,[mbOK],0);
end;

function usuref(
const TheFormat: string;
const Args:array of const):boolean;
begin
  result := usure(format(Theformat,args));
end;

{ returns s[i], but if that's empty, returns chr$(0). }
function emptyspace(s:string; i:integer):char;
begin
  if length(s)<i then
  result := chr(0)
  else
  result := s[i];
end;

function commaoid(s:string):string;
var
i:integer;
begin
  i := pos(',',s);
  if i > 0 then
  result := copy(s,i+1,500)
  else
  result := '';
end;

{ a utility procedure that extracts a value after a colon. If
s is "1234:45:987", colonoid will change s to "45:987" and set
x to 45. }
procedure colonoid(var s:string; var x:longint);
var i:integer;
begin
  i := pos(':',s);
  if i > 0 then begin
    s := copy(s,i+1,500);
    x := jgoStrToInt(s);
  end;
end;

procedure editselect(edit:TEdit);
begin
  edit.SelStart := 0;
  edit.SelLength := length(edit.text);
end;

procedure replacechar(old,new:char; var dst:string);
var
i:integer;
begin
  for i:=1 to length(dst) do begin
    if dst[i]=old then
    dst[i] := new;
  end;
end;


function firstselected(listbox:Tlistbox):integer;
var
i:integer;
begin
  result := 0;
  for i:=0 to listbox.items.count-1 do begin
    if listbox.selected[i] then begin
      result := i;
      exit;
    end;
  end;
end;

function isdefault(s:string):boolean;
begin
  result :=
  (CompareText('DEFAULT',s)=0);
end;

function hexoid(s:string):longint;
begin
  if ( (length(s)>0) and (s[1]='$') ) then
  result := HexToInt(copy(s,2,500))
  else
  result := JgoStrToInt(s);
end;

{ called like
nfree(Tobject(bingo)); }

procedure nfree(var what:Tobject);
begin
  what.free;
  what := nil;
end;

function lastchar(s:string):string;
var
len:integer;
begin
  len := length(s);
  if len > 0 then
  result := s[len]
  else
  result := '';
end;

function firstnumber(s:string):integer;
var
i:integer;
begin
  result := 0;
  for i:= 1 to length(s) do begin
    if isdigit(s[i]) then begin
      result := JgoStrToInt(copy(s,i,500));
      exit;
    end;
  end;
end;


{--------------------------------------------------------------}

var
theoriginaldirectory : string; {no slash}
optioncount : integer;

{fiddle with the string, looking for "%"s.
%1:     replace with ParamStr(1);
%w1:    replace with currentworkingdirectory + ParamStr(1)
}

function argumentize(s:string):string;
var
slength, i : integer;
argnumber : integer;
cwddirectorize : boolean;
t : string;

begin
  result := '';
  slength := length(s);
  i := 1;
  while (i <= slength) do begin
    if s[i]='%' then begin
      argnumber := 0;
      cwddirectorize := false;
      inc(i);  {skip over the %. }
      while(i<=slength) do begin
        case s[i] of
          '0'..'9': argnumber := StrToInt(s[i]);
          'w': cwddirectorize := true;
        else
          break; {the while}
        end;
        inc(i);         {next character}
      end;

      if ( (argnumber>0) and (argnumber <= ParamCount) ) then begin
        t := ParamStr(argnumber+optioncount);
        if (cwddirectorize and (not directorized(t)) ) then
        result := result+theoriginaldirectory+'\'+t
        else
        result := result+t;
      end;
    end else begin
      result := result+s[i];
      inc(i);
    end;
  end;

end;

procedure complainoptions(s:string);
begin
  errorf('Didn''t like option "%s"',[s]);
end;

{****************************************************************************
****************************************************************************}
{ returns s[i], but if that's empty, returns chr$(0). }
function es(s:string; i:integer):char;
begin
  if length(s)<i then
  result := chr(0)
  else
  result := s[i];
end;



function directorized(s:string):boolean;
begin
  result :=
  (pos('\',s)>0) or
  (pos(':',s)>0);
end;

function getCDslash:string;
begin
  result := getCurrentDir;
  slash(result); //it might be d:\.
end;

procedure cwdize(var s:string);

begin

  if (length(s)>0) and (pos('\',s)=0)
  and (pos(':',s)=0) then
//  s := getCurrentDir+'\'+s;
  s := getCDslash+s;

end;

procedure deslash(var what:string);
var i:integer;
begin
  i := length(what);
  if
//  what[i]='\'
  es(what,i)='\'
  then begin
{   what[0] := char(i - 1);  { they don't have a function! }
    setlength(what,i-1);
  end;
end;

procedure slash(var what:string);
begin
  deslash(what);
  what := what + '\';
end;

function fslash(what:string):string;
begin

  slash(what);
  result := what;

end;


procedure eslash(var what:string);
begin
  if length(what)>0 then
  slash(what);
end;

function pgmdir:string;
const
pgmd : string = '';
begin

  if length(pgmd)<1 then begin
    pgmd := ExtractFilePath(ParamStr(0));
    slash(pgmd);
  end;

  result := pgmd;

end;

function haspath(s:string):boolean;
begin
  result :=
  (pos('\',s)>0) or
  (pos(':',s)>0);
end;


procedure pgmdirize(var s:string);
begin

  if (length(s)>0) and
//  (pos('\',s)=0)
//  and (pos(':',s)=0)
  (not haspath(s))
  then

//  s := getCurrentDir+'\'+s;
  s := pgmdir+s;

end;

function fpgmdirize(s:string):string;
begin
  pgmdirize(s);
  result := s;
end;

function programdirectory:string;
begin
  result := ExtractFilePath(ParamStr(0));
  deslash(result);
end;

procedure ChangeToProgramDirectory;
const
done : boolean = false;
var
directory:string;
begin
  if done then
  exit;

  done := true;
{ ExpandFileName ParamStr }
  directory := programdirectory;
  { I think win3.1 aka dos6 whatever doesn't like
  the trailing slash? }
  try
    chdir(directory)
  except
    messagedlg(
    'Unscheduled error: chdir(' +
    directory +
    ') failed; sorry.',
    mtError,[mbOK],0);
  end;
  { try and use current directory. }
end;

function programname:string;
begin
  result := LowerCase(ExtractName(ParamStr(0)));
end;

function cwd:string;
const
cwd : string = '';
begin

  if length(cwd)<1 then begin
    cwd := GetCurrentDir;
    slash(cwd);
  end;

  result := cwd;

end;

function fcwdirize(s:string):string;
begin
  result := s;

  if (length(result)>0) and
  (not haspath(result))
  then

//  s := getCurrentDir+'\'+s;
   result := cwd+result;

end;

procedure delphi_yield;
const
here : boolean = false;
begin
  if here then
  exit;

  here := true;

  Application.HandleMessage;
  Application.ProcessMessages;

  here := false;
end;

function safe_format(
const TheFormat: string;
const Args:array of const):string;
begin
  try
    result := format(Theformat,args);
  except
    on e: exception do
    result :=
    format('Format() error in program!'+LNEND+'Error:'+LNEND+'%s'+LNEND+
    'Format:'+LNEND+'%s',[e.message,TheFormat]);
  end;
end;



{****************************************************************************
****************************************************************************}

procedure stupidscroll(memo:Tmemo);
begin
//1.
//  Memo.SelLength := 0;
//  Memo.SelStart := length(memo.text);
//  SendMessage(Memo.Handle, EM_LINESCROLL, 0,Memo.Lines.Count);

//2.  Memo.Lines.Add('A Line of text or more');
//  Memo.SelStart := Memo.GetTextLen;
//  Memo.SelLength := 0;
//  Memo.ScrollBy(0, Memo.Lines.Count);
//  Memo.Refresh;

//3.
  memo.SelStart:=Length(memo.Text);
  memo.SelLength:=0;
  SendMessage(memo.Handle, EM_SCROLLCARET, 0, 0);

end;



{$ifdef NOT_INNERESTED}
{--------------------------------------------------------------}
procedure finalsbrs; far;
begin
  unloadWLC6font;
end;

initialization

AddExitProc(finalsbrs);

theoriginaldirectory := GetCurrentDir;
{$endif}


end.
